/*
SUSIE32 '00AM' Plug-in for LZH(LH0̂)
*/

#include <windows.h>
#include "spi00am.h"
#include "spi00am_ex.h"
extern "C" {
#include "fitz.h"
#include "mupdf.h"
}
#define XMD_H
#define HAVE_BOOLEAN
#define NEED_FAR_POINTERS
#include "jpeglib.h"
#undef XMD_H
#undef HAVE_BOOLEAN
#undef NEED_FAR_POINTERS
int g_resolution = 144;//dpi
#if 1
void llog(char *s){}
#elif
void llog(char *s) { FILE *fp=fopen("r:/output.log", "a");fprintf(fp,"%s\n",s);fclose(fp);}
#endif
HANDLE g_hModule;
void loadConfig()
{
	char iniFile[1024];
	GetModuleFileName((HMODULE)g_hModule, iniFile, 1024);
	strcpy(iniFile+strlen(iniFile)-4, ".ini");
	g_resolution = GetPrivateProfileInt("Setting", "dpi", g_resolution, iniFile);
}
int GetJpegToMemory(HLOCAL *hLocal, unsigned long *buf_size, pdf_xref *xref, pdf_page *page, int resolution)
{
	fz_display_list *list;
	fz_device *dev;
	fz_colorspace *colorspace = fz_device_rgb;
	struct jpeg_compress_struct cinfo;
	struct jpeg_error_mgr jerr;
	JSAMPARRAY img;

	llog("GetJpegToMemory");
	cinfo.err = jpeg_std_error(&jerr);

	jpeg_create_compress(&cinfo);
	float zoom;
	fz_matrix ctm;
	fz_bbox bbox;
	fz_pixmap *pix;
	fz_glyph_cache_s *glyphcache;

	zoom = (float)resolution / 72;
	ctm = fz_translate(0, -page->mediabox.y1);
	ctm = fz_concat(ctm, fz_scale(zoom, -zoom));
	ctm = fz_concat(ctm, fz_rotate(page->rotate));
	bbox = fz_round_rect(fz_transform_rect(ctm, page->mediabox));

	pix = fz_new_pixmap_with_rect(colorspace, bbox);
	fz_clear_pixmap_with_color(pix, 255);

	glyphcache = fz_new_glyph_cache();
	dev = fz_new_draw_device(glyphcache, pix);
	pdf_run_page(xref, page, dev, ctm);
	fz_free_device(dev);

	fz_write_pnm(pix, "output.ppm");

	cinfo.image_width = pix->w;
	cinfo.image_height = pix->h;
	cinfo.input_components = 3;
	cinfo.in_color_space = JCS_RGB;
	jpeg_set_defaults(&cinfo);
	jpeg_set_quality(&cinfo, 100, TRUE);

	*buf_size = pix->w*pix->h*3;
	*hLocal = LocalAlloc(LMEM_FIXED, *buf_size);
	if (*hLocal == NULL) {
		return SPI_NO_MEMORY;
	}
	unsigned char * buf = (unsigned char *)*hLocal;

	jpeg_mem_dest(&cinfo, &buf, buf_size);
	jpeg_start_compress(&cinfo, TRUE);

	JSAMPROW row_pointer[1];
	JSAMPROW row;
	row = (JSAMPROW)malloc(sizeof(JSAMPLE)*pix->w*3);
	if (row == NULL) {
		return SPI_NO_MEMORY;
	}
	unsigned char *ps = pix->samples, *pd;
	for (int i=0;i<pix->h;i++) {
		pd = row;
		for (int j=0;j<pix->w;j++) {
			*(pd++) = *(ps++);
			*(pd++) = *(ps++);
			*(pd++) = *(ps++);
			ps++;
		}
		row_pointer[0] = row;
		jpeg_write_scanlines(&cinfo, row_pointer, 1);
	}

	jpeg_finish_compress(&cinfo);
	free(row);
	fz_free_glyph_cache(glyphcache);
	fz_drop_pixmap(pix);
	jpeg_destroy_compress(&cinfo);

	llog("return 0");
	return 0;
}
//---------------------------------------------------------------------------
/* Gg|Cg */
BOOL APIENTRY SpiEntryPoint(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	g_hModule = hModule;
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

//---------------------------------------------------------------------------
/*
wb_đΉtH[}bgmF.
ΉĂ̂Ȃtrue,łȂfalseԂ.
filname̓t@C(NULLĂ邱Ƃ).
data̓t@C̃wb_,TCY HEADBUF_SIZE.
*/
/* 2KBȓ */
BOOL IsSupportedEx(char *filename, char *data)
{
	if (memcmp(data, "%PDF-", 5) != 0) return FALSE;
	return TRUE;
}
//---------------------------------------------------------------------------
/*
filname̓t@C.
len͓ǂݍ݊JnItZbg(MacBinΉ̂).
lphInf̓t@C̓nh󂯎ϐւ̃|C^.
A[JCu擾.G[R[hԂ.

A[JCu͓ƎɂxLbVB
GetArchiveInfo ł *A[JCut@C* ̈v̂ԂB
GetFileInfo ł̓A[JCu *t@C* ̈v̂ԂB
GetFileEx œn fileInfo  *posiion* ̈v̂nB
*/
int GetArchiveInfoEx(LPSTR filename, long len, HLOCAL *lphInf)
{

	pdf_xref *xref;
	pdf_page *page;
	int fcount = 0;
	unsigned long filesize;
	fz_error error;
	loadConfig();

	error = pdf_open_xref(&xref, filename, NULL);
	if (error) { return SPI_FILE_READ_ERROR;}
	if (pdf_needs_password(xref)) {
		return SPI_FILE_READ_ERROR;
	}
	error = pdf_load_page_tree(xref);
	if (error) { return SPI_FILE_READ_ERROR;}
	fcount = pdf_count_pages(xref);
	*lphInf = LocalAlloc(LPTR, sizeof(fileInfo)*(fcount+1));
	if (*lphInf == NULL) {
		pdf_free_xref(xref);
		return SPI_NO_MEMORY;
	}
	fileInfo *pinfo = (fileInfo *)*lphInf;
	HLOCAL dest;
	for (int i=0; i < fcount; i++) {
		error = pdf_load_page(&page, xref, i);
		int ret = GetJpegToMemory(&dest, &filesize, xref, page, g_resolution);
		pdf_free_page(page);
		if (ret != 0) return ret;
		LocalFree(dest);
		/* Method(7+'\0'ȓł̓Kȕԋp) */
		lstrcpy((char*)pinfo->method, "MuPDF");
		pinfo->position = i;
		pinfo->compsize = filesize;
		pinfo->filesize = filesize;
		pinfo->timestamp = 0;
		sprintf((char*)pinfo->filename, "%03d.jpg", i);
		pinfo->crc = 0;
		pinfo++;
	}
	pinfo->method[0] = '\0';
	pdf_free_xref(xref);

	return SPI_ALL_RIGHT;
}
//---------------------------------------------------------------------------
/*
dest,t@C̓LOCAL[nh󂯎ϐւ̃|C^.
w肳ꂽfileInfo\̂ւ̃|C^.
G[R[hԂ.
*/
int GetFileEx(char *filename, HLOCAL *dest, fileInfo *pinfo,
			SPI_PROGRESS lpPrgressCallback, long lData)
{
	llog("GetFileEx");
	pdf_xref *xref;
	pdf_page *page;
	fz_error error;
	int pagenum = pinfo->position;
	unsigned long filesize;
	loadConfig();
	error = pdf_open_xref(&xref, filename, NULL);
	if (error) {
		llog("open error");
		return SPI_MEMORY_ERROR;
	}
	error = pdf_load_page_tree(xref);
	if (error) {
		llog("tree error");
		return SPI_FILE_READ_ERROR;
	}
	error = pdf_load_page(&page, xref, pagenum);
	if (error) {
		llog("load page error");
		return SPI_FILE_READ_ERROR;
	}
	GetJpegToMemory(dest, &filesize, xref, page, g_resolution);
#if 0
	HANDLE hf;
	DWORD ReadBytes;
	LHA_H2 lha_h;

	hf = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hf == INVALID_HANDLE_VALUE) return SPI_FILE_READ_ERROR;
	if (SetFilePointer(hf, pinfo->position, NULL, FILE_BEGIN) != (DWORD)pinfo->position) {
		CloseHandle(hf);
		return SPI_FILE_READ_ERROR;
	}
	ReadFile(hf, &lha_h, sizeof(LHA_H2), &ReadBytes, NULL);
	*dest = LocalAlloc(LMEM_FIXED, lha_h.filesize);
	if (*dest == NULL) {
		CloseHandle(hf);
		return SPI_NO_MEMORY;
	}
	SetFilePointer(hf, lha_h.size -sizeof(LHA_H2), NULL, FILE_CURRENT);
	ReadFile(hf, (char *)*dest, lha_h.filesize, &ReadBytes, NULL);
	CloseHandle(hf);

#endif
	return SPI_ALL_RIGHT;
}

